# pjisuv程序非特指朴津多功能车，为双芯片域控程序统一使用。
# 一、代码结构解释（以pjisuv为例）
## 1-1 common
- 公用函数、配置
## 1-2 control
- 监听数据闭环平台任务配置信息
- 双芯片域控的两个芯片均需要部署
- 当监听到任务启动时，分别在两个芯片启动 master 工具 和 slave 工具
## 1-3 master
- 主节点的数据采集工具
- 负责读取触发器信息，监听ROS数据，生成场景时间窗口
- 负责存储主节点数据，触发后截取窗口内数据上传到云端
## 1-4 slave
- 从节点的数据采集工具
- 负责接收主节点发送过来的场景时间窗口
- 负责存储从节点数据，触发后截取窗口内数据上传到云端



# 所有分支
v2025.1.2: 准备开启吉利项目开发，代码定版


# 注意事项
- go.mod不要动
- msgs目录内容非必要不修改
- 共享变量方式
  - （新方案）采用 sync.Map，将触发器与 param 包解耦 
  - pjisuvParam 结构体不要再修改，已废弃方案
- 添加共享变量时
  - 如果有新的topic需要被订阅，需要在 trigger_var.go 文件中添加
  - 需要修改produce_window.go文件中的订阅者，将触发器>0条件去掉

# 一、代码目录结构

## 1-1 trigger目录
- 触发器


## 1-2 xxx_msgs目录
- ros消息定义
 
## aarch64/pjisuv
## 目录结构
### common
- c_cloud.go：阿里云oss配置文件下载解析
### control 调度程序
### master 102 程序
- trigger_init.go：102 初始化加载触发器插件
### slave 103 程序

# 阿里云oss连接

```
cname：http://open-bucket.oss.icvdc.com
keyid：n8glvFGS25MrLY7j
secret：xZ2Fozoarpfw0z28FUhtg8cu0yDc5d
预设OSS路径： oss://open-bucket
```

```
cname：http://pji-bucket1.oss.icvdc.com
keyid：n8glvFGS25MrLY7j
secret：xZ2Fozoarpfw0z28FUhtg8cu0yDc5d
预设OSS路径： oss://pji-bucket1
```



# 采集话题
## 引导机器人
rosbag record --split --duration=1  /amcl_pose /ob_camera_01/color/image_raw /ob_camera_02/color/image_raw /diagnostics /locate_info /obstacle_detection /odom /move_base/global_costmap/costmap /move_base/global_costmap/costmap_updates /move_base/local_costmap/costmap /move_base/local_costmap/costmap_updates /scan /scan_map_icp_amcl_node/scan_point_transformed /sys_info /imu /depth_scan_02 /map /scan_filtered /sonar_left /sonar_right /sonar_mid /sonar_rmid /tf /tf_static /cmd_vel /move_base/DWAPlannerROS/global_plan /move_base/DWAPlannerROS/local_plan /move_base/GlobalPlanner/plan /move_base/global_costmap/footprint /move_base/local_costmap/footprint /robot_pose_tf
## 配送机器人 & 巡检机器人
rosbag record --split --duration=1 /robot_pose /robot/realtime_cost_map_ /tracking/objects /robot/TaskInfo /robot/targetposition /wheel /wheel_odom /robot/global_trajectory_ /robot/target_trajectories /robot/evaluator_trajectories /robot/final_trajectory /nav/task_feedback_info /cmd_vel /imu /points_cluster /nav/task_feedback_info /points_concat /velodyne_points /image_raw /prediction/motion_predictor/objects